/* CalendarHelp internal component - Source at http://calendarhelp.mozdev.org - Subject to copyright and license terms */
CalHelpSidebar = {
box: null,button: null,splitter: null,toc: null,search: null,suffix: "",init: function () {
this.box = document.getElementById("help-sidebar");
this.button = document.getElementById("help-sidebar-button")
this.splitter = document.getElementById("help-sidebar-splitter")
this.toc = document.getElementById("help-toc-sidebar")
this.search = document.getElementById("help-search-sidebar")
this.suffix = document.documentElement.getAttribute("titlesuffix")
document.getElementById("context-reload").collapsed = true
document.getElementById("findText").addEventListener(
"command",function () {CalHelpSidebar.toggle(true)},false)
document.getElementById("help-content").addEventListener(
"DOMTitleChanged",function (event) {
CalHelpSidebar.title = event.target.title},false)},contents: function (show) {
if (show) {
this.toc.removeAttribute("hidden")
this.search.setAttribute("hidden", "true")}
else {
this.search.removeAttribute("hidden")
this.toc.setAttribute("hidden", "true")}},resized: function () {
this.button.checked = this.box.collapsed},set title (t) {
if (t) document.title = t.indexOf(this.suffix) > 0 ? t : t + " - " + this.suffix},toggle: function (seen) {
with (this.box) {
if (seen == !collapsed) return;
if (seen == undefined) seen = collapsed;
collapsed = !seen;}
this.splitter.setAttribute("state", (seen ? "" : "collapsed"))
setTimeout("CalHelpSidebar.button.checked = " + !seen, 0)}}
CalHelpSearch = {
result: null,text: null,tree: null,suffix: "",nothing: "",RDF: Components.classes['@mozilla.org/rdf/rdf-service;1'].getService(Components.interfaces.nsIRDFService),CU: Components.classes['@mozilla.org/rdf/container-utils;1'].getService(Components.interfaces.nsIRDFContainerUtils),root: this.RDF.GetResource("urn:root"),subs: this.RDF.GetResource("http://home.netscape.com/NC-rdf#subheadings"),name: this.RDF.GetResource("http://home.netscape.com/NC-rdf#name"),link: this.RDF.GetResource("http://home.netscape.com/NC-rdf#link"),type: this.RDF.GetResource("http://home.netscape.com/NC-rdf#type"),child: this.RDF.GetResource("http://home.netscape.com/NC-rdf#child"),glossary: [],index: [],toc: [],init: function () {
this.text = document.getElementById("findText")
this.tree = document.getElementById("help-search-tree")
this.suffix = " " + this.tree.getAttribute("glossarysuffix")
this.nothing = this.tree.getAttribute("nothingfound")
this._load(
this.glossary,this.RDF.GetDataSourceBlocking("chrome://calendarhelp/locale/glossary.rdf"),this.root,"glossary")
this._load(
this.index,this.RDF.GetDataSourceBlocking("chrome://calendarhelp/locale/index.rdf"),this.root,"index")
this._load(
this.toc,this.RDF.GetDataSourceBlocking("chrome://calendarhelp/locale/toc.rdf"),this.root,"toc")
window.doFind = function () {CalHelpSearch.doFind()}
var b = this.tree.getElementsByTagName("bindings")[0]
with (b.appendChild(document.createElement("binding"))) {
setAttribute("subject", "?subheading")
setAttribute("predicate", "http://home.netscape.com/NC-rdf#type")
setAttribute("object", "?type")}
this.tree.getElementsByTagName("treecell")[0].setAttribute("properties", "?type")},_load: function (a, ds, res, type, prefix) {
var t = ds.GetTarget(res, this.subs, true)
if (!t) return
var en = this.CU.MakeSeq(ds, t).GetElements()
while (en.hasMoreElements()) {
var r = en.getNext().QueryInterface(Components.interfaces.nsIRDFResource)
var l = ds.GetTarget(r, this.link, true)
var n = ds.GetTarget(r, this.name, true).QueryInterface(Components.interfaces.nsIRDFLiteral).Value
if (l) a.push({
type: type,name: prefix ? prefix + "," + n : n,link: l.QueryInterface(Components.interfaces.nsIRDFLiteral).Value})
this._load(a, ds, r, type, type == "index" && n.length > 1 ? n : "")}},doFind: function () {
var s = this.text.value.replace(/^\s+/, "").replace(/\s+$/, "").replace(/\s{2,}/, " ").replace(/[\\\^\$\+\*\?\[\]\(\)\{\}]/g, "")
this.text.value = s
if (s.length < 2) return
var re = new RegExp(s, "i")
var r = []
for each (var v in this.glossary) if (re.test(v.name)) r.push(v)
for each (var v in this.index) if (re.test(v.name)) r.push(v)
for each (var v in this.toc) if (re.test(v.name)) r.push(v)
if (this.result) this.tree.database.RemoveDataSource(this.result)
this.result = Components.classes["@mozilla.org/rdf/datasource;1?name=in-memory-datasource"].createInstance(Components.interfaces.nsIRDFDataSource)
if (r.length == 0) {
var res = this.RDF.GetAnonymousResource()
with (this.result) {
Assert(res, this.type, this.RDF.GetLiteral("empty"), true)
Assert(res, this.name, this.RDF.GetLiteral(this.nothing), true)
Assert(this.root, this.child, res, true)}}
else {
r.sort(function(a, b) {
var av = a.link, bv = b.link
if (av == bv) {
var p = {index: 2, glossary: 1, toc: 0}
av = p[a.type], bv = p[b.type]}
if (av == bv) av = b.name.length, bv = a.name.length
return (av == bv)? 0 : (av > bv)? 1 : -1})
var link = null
for each (var v in r) {
var l = v.link
if (link && l == link) v.link = null, v.name = ""
else link = l}
r.sort(function(a, b) {
var av = a.name.toLowerCase(), bv = b.name.toLowerCase()
return (av == bv)? 0 : (av > bv)? 1 : -1})
for each (var v in r) {
if (!v.link) continue
var res = this.RDF.GetAnonymousResource()
with (this.result) {
Assert(
res,this.type,this.RDF.GetLiteral(v.type),true)
Assert(
res,this.name,this.RDF.GetLiteral(v.name + (v.type == "glossary" ? this.suffix : "")),true)
Assert(
res,this.link,this.RDF.GetLiteral(v.link),true)
Assert(this.root, this.child, res, true)}}}
this.tree.database.AddDataSource(this.result)
this.tree.builder.rebuild()
CalHelpSidebar.contents(false)}}
addEventListener(
"load",function () {
CalHelpSidebar.init()
CalHelpSearch.init()},false)
